" VIM Syntax file for txr
" Kaz Kylheku <kaz@kylheku.com>

" INSTALL-HOWTO:
"
" 1. Create the directory .vim/syntax in your home directory and
"    put the files txr.vim and txl.vim into this directory.
" 2. In your .vimrc, add this command to associate *.txr and *.tl
"    files with the txr and txl filetypes:
"    :au BufRead,BufNewFile *.txr set filetype=txr | set lisp
"    :au BufRead,BufNewFile *.tl set filetype=txl | set lisp
"
" If you want syntax highlighting to be on automatically (for any language)
" you need to add ":syntax on" in your .vimrc also. But you knew that already!
"
" This file is generated by the genvim.txr script in the TXR source tree.

syn case match
syn spell toplevel

setlocal iskeyword=a-z,A-Z,48-57,!,$,&,*,+,-,:,<,=,>,?,\\,_,~,/

syn keyword txl_keyword contained %e% %pi% * *args*
syn keyword txl_keyword contained *args-full* *e* *flo-dig* *flo-epsilon*
syn keyword txl_keyword contained *flo-max* *flo-min* *full-args* *gensym-counter*
syn keyword txl_keyword contained *keyword-package* *lib-version* *listener-hist-len* *listener-multi-line-p*
syn keyword txl_keyword contained *pi* *place-clobber-expander* *place-delete-expander* *place-macro*
syn keyword txl_keyword contained *place-update-expander* *print-base* *print-flo-digits* *print-flo-format*
syn keyword txl_keyword contained *print-flo-precision* *random-state* *self-path* *stddebug*
syn keyword txl_keyword contained *stderr* *stdin* *stdlog* *stdnull*
syn keyword txl_keyword contained *stdout* *system-package* *txr-version* *unhandled-hook*
syn keyword txl_keyword contained *user-package* + - /
syn keyword txl_keyword contained /= : :addr :append
syn keyword txl_keyword contained :args :atime :auto :blksize
syn keyword txl_keyword contained :blocks :cdigit :chars :continue
syn keyword txl_keyword contained :counter :cspace :ctime :cword-char
syn keyword txl_keyword contained :decline :dev :digit :downcase
syn keyword txl_keyword contained :env :equal-based :fd :filter
syn keyword txl_keyword contained :fini :finish :form :from-current
syn keyword txl_keyword contained :from-end :from-start :from_html :frombase64
syn keyword txl_keyword contained :fromhtml :frompercent :fromurl :fun
syn keyword txl_keyword contained :function :gap :gid :greedy
syn keyword txl_keyword contained :hextoint :init :ino :instance
syn keyword txl_keyword contained :into :lfilt :lines :list
syn keyword txl_keyword contained :longest :mandatory :maxgap :maxtimes
syn keyword txl_keyword contained :method :mingap :mintimes :mode
syn keyword txl_keyword contained :mtime :name :named :next-spec
syn keyword txl_keyword contained :nlink :nothrow :postinit :prio
syn keyword txl_keyword contained :rdev :real-time :reflect :repeat-spec
syn keyword txl_keyword contained :resolve :rfilt :shortest :size
syn keyword txl_keyword contained :space :static :string :symacro
syn keyword txl_keyword contained :times :to_html :tobase64 :tofloat
syn keyword txl_keyword contained :tohtml :tohtml* :toint :tonumber
syn keyword txl_keyword contained :topercent :tourl :uid :upcase
syn keyword txl_keyword contained :var :vars :weak-keys :weak-vals
syn keyword txl_keyword contained :whole :word-char :wrap <
syn keyword txl_keyword contained <= = > >=
syn keyword txl_keyword contained abort abs abs-path-p acons
syn keyword txl_keyword contained acons-new aconsql-new acos ado
syn keyword txl_keyword contained af-inet af-inet6 af-unix af-unspec
syn keyword txl_keyword contained ai-addrconfig ai-all ai-canonname ai-numerichost
syn keyword txl_keyword contained ai-numericserv ai-passive ai-v4mapped alist-nremove
syn keyword txl_keyword contained alist-remove all and andf
syn keyword txl_keyword contained ap apf append append*
syn keyword txl_keyword contained append-each append-each* apply aret
syn keyword txl_keyword contained ash asin assoc assql
syn keyword txl_keyword contained atan atan2 atom base64-decode
syn keyword txl_keyword contained base64-encode bignump bindable bit
syn keyword txl_keyword contained block block* boundp break-str
syn keyword txl_keyword contained butlast caaaaar caaaadr caaaar
syn keyword txl_keyword contained caaadar caaaddr caaadr caaar
syn keyword txl_keyword contained caadaar caadadr caadar caaddar
syn keyword txl_keyword contained caadddr caaddr caadr caar
syn keyword txl_keyword contained cadaaar cadaadr cadaar cadadar
syn keyword txl_keyword contained cadaddr cadadr cadar caddaar
syn keyword txl_keyword contained caddadr caddar cadddar caddddr
syn keyword txl_keyword contained cadddr caddr cadr call
syn keyword txl_keyword contained call-clobber-expander call-delete-expander call-finalizers call-super-fun
syn keyword txl_keyword contained call-super-method call-update-expander callf car
syn keyword txl_keyword contained caseq caseql casequal cat-str
syn keyword txl_keyword contained cat-streams cat-vec catch catenated-stream-p
syn keyword txl_keyword contained catenated-stream-push cdaaaar cdaaadr cdaaar
syn keyword txl_keyword contained cdaadar cdaaddr cdaadr cdaar
syn keyword txl_keyword contained cdadaar cdadadr cdadar cdaddar
syn keyword txl_keyword contained cdadddr cdaddr cdadr cdar
syn keyword txl_keyword contained cddaaar cddaadr cddaar cddadar
syn keyword txl_keyword contained cddaddr cddadr cddar cdddaar
syn keyword txl_keyword contained cdddadr cdddar cddddar cdddddr
syn keyword txl_keyword contained cddddr cdddr cddr cdr
syn keyword txl_keyword contained ceil chain chand chdir
syn keyword txl_keyword contained chmod chr-digit chr-int chr-isalnum
syn keyword txl_keyword contained chr-isalpha chr-isascii chr-isblank chr-iscntrl
syn keyword txl_keyword contained chr-isdigit chr-isgraph chr-islower chr-isprint
syn keyword txl_keyword contained chr-ispunct chr-isspace chr-isunisp chr-isupper
syn keyword txl_keyword contained chr-isxdigit chr-num chr-str chr-str-set
syn keyword txl_keyword contained chr-tolower chr-toupper chr-xdigit chrp
syn keyword txl_keyword contained clamp clear-error clear-struct close-stream
syn keyword txl_keyword contained closelog cmp-str collect-each collect-each*
syn keyword txl_keyword contained comb compl-span-str cond conda
syn keyword txl_keyword contained condlet cons conses conses*
syn keyword txl_keyword contained consp constantp copy copy-alist
syn keyword txl_keyword contained copy-cons copy-hash copy-list copy-str
syn keyword txl_keyword contained copy-struct copy-vec cos count-if
syn keyword txl_keyword contained countq countql countqual crypt
syn keyword txl_keyword contained cum-norm-dist daemon dec defex
syn keyword txl_keyword contained define-accessor define-modify-macro define-place-macro defmacro
syn keyword txl_keyword contained defmeth defparm defparml defplace
syn keyword txl_keyword contained defstruct defsymacro defun defvar
syn keyword txl_keyword contained defvarl del delay delete-package
syn keyword txl_keyword contained display-width do dohash dotimes
syn keyword txl_keyword contained downcase-str drop drop-until drop-while
syn keyword txl_keyword contained dup dupfd dwim each
syn keyword txl_keyword contained each* eighth empty endgrent
syn keyword txl_keyword contained endpwent ensure-dir env env-fbind
syn keyword txl_keyword contained env-hash env-vbind eq eql
syn keyword txl_keyword contained equal errno error eval
syn keyword txl_keyword contained evenp exception-subtype-p exec exit
syn keyword txl_keyword contained exit* exp expand-left expand-right
syn keyword txl_keyword contained expt exptmod false fboundp
syn keyword txl_keyword contained fifth fileno filter-equal filter-string-tree
syn keyword txl_keyword contained finalize find find-frame find-if
syn keyword txl_keyword contained find-max find-min find-package find-struct-type
syn keyword txl_keyword contained first fixnump flatcar flatcar*
syn keyword txl_keyword contained flatten flatten* flet flip
syn keyword txl_keyword contained flipargs flo-dig flo-epsilon flo-int
syn keyword txl_keyword contained flo-max flo-max-dig flo-min flo-str
syn keyword txl_keyword contained floatp floor flush-stream fmakunbound
syn keyword txl_keyword contained for for* force fork
syn keyword txl_keyword contained format fourth from fstat
syn keyword txl_keyword contained fun func-get-env func-get-form func-get-name
syn keyword txl_keyword contained func-set-env functionp gcd gen
syn keyword txl_keyword contained generate gensym gequal get-byte
syn keyword txl_keyword contained get-char get-clobber-expander get-delete-expander get-error
syn keyword txl_keyword contained get-error-str get-frames get-hash-userdata get-indent
syn keyword txl_keyword contained get-indent-mode get-line get-lines get-list-from-stream
syn keyword txl_keyword contained get-sig-handler get-string get-string-from-stream get-update-expander
syn keyword txl_keyword contained getaddrinfo getegid getenv geteuid
syn keyword txl_keyword contained getgid getgrent getgrgid getgrnam
syn keyword txl_keyword contained getgroups gethash getitimer getpid
syn keyword txl_keyword contained getppid getpwent getpwnam getpwuid
syn keyword txl_keyword contained getuid ginterate giterate glob
syn keyword txl_keyword contained glob-altdirfunc glob-brace glob-err glob-mark
syn keyword txl_keyword contained glob-nocheck glob-noescape glob-nomagic glob-nosort
syn keyword txl_keyword contained glob-onlydir glob-period glob-tilde glob-tilde-check
syn keyword txl_keyword contained greater group-by group-reduce gun
syn keyword txl_keyword contained handle handler-bind hash hash-alist
syn keyword txl_keyword contained hash-begin hash-construct hash-count hash-diff
syn keyword txl_keyword contained hash-eql hash-equal hash-from-pairs hash-isec
syn keyword txl_keyword contained hash-keys hash-list hash-next hash-pairs
syn keyword txl_keyword contained hash-proper-subset hash-revget hash-subset hash-uni
syn keyword txl_keyword contained hash-update hash-update-1 hash-values hashp
syn keyword txl_keyword contained have html-decode html-encode html-encode*
syn keyword txl_keyword contained iapply identity ido if
syn keyword txl_keyword contained ifa iff iffi iflet
syn keyword txl_keyword contained ignerr in in6addr-any in6addr-loopback
syn keyword txl_keyword contained inaddr-any inaddr-loopback inc inc-indent
syn keyword txl_keyword contained indent-code indent-data indent-off inhash
syn keyword txl_keyword contained int-chr int-flo int-str integerp
syn keyword txl_keyword contained intern interp-fun-p interpose invoke-catch
syn keyword txl_keyword contained ip ipf iread isqrt
syn keyword txl_keyword contained itimer-prov itimer-real itimer-virtual juxt
syn keyword txl_keyword contained keep-if keep-if* keyword-package keywordp
syn keyword txl_keyword contained kill labels lambda last
syn keyword txl_keyword contained lazy-str lazy-str-force lazy-str-force-upto lazy-str-get-trailing-list
syn keyword txl_keyword contained lazy-stream-cons lazy-stringp lcm lcons
syn keyword txl_keyword contained lcons-fun lconsp ldiff length
syn keyword txl_keyword contained length-list length-str length-str-< length-str-<=
syn keyword txl_keyword contained length-str-> length-str->= length-vec lequal
syn keyword txl_keyword contained less let let* lexical-fun-p
syn keyword txl_keyword contained lexical-lisp1-binding lexical-var-p lib-version link
syn keyword txl_keyword contained lisp-parse list list* list-str
syn keyword txl_keyword contained list-vec list-vector listp lnew
syn keyword txl_keyword contained load log log-alert log-auth
syn keyword txl_keyword contained log-authpriv log-cons log-crit log-daemon
syn keyword txl_keyword contained log-debug log-emerg log-err log-info
syn keyword txl_keyword contained log-ndelay log-notice log-nowait log-odelay
syn keyword txl_keyword contained log-perror log-pid log-user log-warning
syn keyword txl_keyword contained log10 log2 logand logior
syn keyword txl_keyword contained lognot logtest logtrunc logxor
syn keyword txl_keyword contained lstat mac-param-bind macro-ancestor macro-form-p
syn keyword txl_keyword contained macro-time macroexpand macroexpand-1 macrolet
syn keyword txl_keyword contained major make-catenated-stream make-env make-hash
syn keyword txl_keyword contained make-lazy-cons make-lazy-struct make-like make-package
syn keyword txl_keyword contained make-random-state make-similar-hash make-string-byte-input-stream make-string-input-stream
syn keyword txl_keyword contained make-string-output-stream make-strlist-output-stream make-struct make-struct-type
syn keyword txl_keyword contained make-sym make-time make-time-utc make-trie
syn keyword txl_keyword contained makedev makunbound mapcar mapcar*
syn keyword txl_keyword contained mapdo mapf maphash mappend
syn keyword txl_keyword contained mappend* mask match-fun match-regex
syn keyword txl_keyword contained match-regex-right match-regst match-regst-right match-str
syn keyword txl_keyword contained match-str-tree max mboundp member
syn keyword txl_keyword contained member-if memq memql memqual
syn keyword txl_keyword contained merge meth method min
syn keyword txl_keyword contained minor minusp mkdir mknod
syn keyword txl_keyword contained mkstring mlet mmakunbound mod
syn keyword txl_keyword contained multi multi-sort n-choose-k n-perm-k
syn keyword txl_keyword contained nconc new nexpand-left nil
syn keyword txl_keyword contained nilf ninth none not
syn keyword txl_keyword contained notf nreconc nreverse nthcdr
syn keyword txl_keyword contained null nullify num-chr num-str
syn keyword txl_keyword contained numberp oand obtain obtain-block
syn keyword txl_keyword contained oddp op open-command open-directory
syn keyword txl_keyword contained open-file open-fileno open-files open-files*
syn keyword txl_keyword contained open-pipe open-process open-socket open-tail
syn keyword txl_keyword contained openlog opip or orf
syn keyword txl_keyword contained package-alist package-name package-symbols packagep
syn keyword txl_keyword contained pad partition partition* partition-by
syn keyword txl_keyword contained path-blkdev-p path-chrdev-p path-dir-p path-executable-to-me-p
syn keyword txl_keyword contained path-exists-p path-file-p path-mine-p path-my-group-p
syn keyword txl_keyword contained path-newer path-older path-pipe-p path-private-to-me-p
syn keyword txl_keyword contained path-same-object path-setgid-p path-setuid-p path-sock-p
syn keyword txl_keyword contained path-sticky-p path-symlink-p path-writable-to-me-p perm
syn keyword txl_keyword contained pipe place-form-p placelet placelet*
syn keyword txl_keyword contained plusp poll poll-err poll-in
syn keyword txl_keyword contained poll-nval poll-out poll-pri poll-rdband
syn keyword txl_keyword contained poll-wrband pop pos pos-if
syn keyword txl_keyword contained pos-max pos-min posq posql
syn keyword txl_keyword contained posqual pppred ppred pprinl
syn keyword txl_keyword contained pprint pprof pred prinl
syn keyword txl_keyword contained print prof prog1 progn
syn keyword txl_keyword contained promisep prop proper-listp pset
syn keyword txl_keyword contained push pushhash pushnew put-byte
syn keyword txl_keyword contained put-char put-line put-lines put-string
syn keyword txl_keyword contained put-strings pwd qquote qref
syn keyword txl_keyword contained quote raise rand random
syn keyword txl_keyword contained random-fixnum random-state-get-vec random-state-p range
syn keyword txl_keyword contained range* range-regex rangep rcomb
syn keyword txl_keyword contained rcons read read-until-match readlink
syn keyword txl_keyword contained real-time-stream-p record-adapter reduce-left reduce-right
syn keyword txl_keyword contained ref refset regex-compile regex-parse
syn keyword txl_keyword contained regexp register-exception-subtypes regsub rehome-sym
syn keyword txl_keyword contained remhash remove-if remove-if* remove-path
syn keyword txl_keyword contained remq remq* remql remql*
syn keyword txl_keyword contained remqual remqual* rename-path repeat
syn keyword txl_keyword contained replace replace-list replace-str replace-struct
syn keyword txl_keyword contained replace-vec reset-struct rest ret
syn keyword txl_keyword contained retf return return* return-from
syn keyword txl_keyword contained revappend reverse rlcp rlet
syn keyword txl_keyword contained rotate rperm rplaca rplacd
syn keyword txl_keyword contained run s-ifblk s-ifchr s-ifdir
syn keyword txl_keyword contained s-ififo s-iflnk s-ifmt s-ifreg
syn keyword txl_keyword contained s-ifsock s-irgrp s-iroth s-irusr
syn keyword txl_keyword contained s-irwxg s-irwxo s-irwxu s-isgid
syn keyword txl_keyword contained s-isuid s-isvtx s-iwgrp s-iwoth
syn keyword txl_keyword contained s-iwusr s-ixgrp s-ixoth s-ixusr
syn keyword txl_keyword contained search search-regex search-regst search-str
syn keyword txl_keyword contained search-str-tree second seek-stream select
syn keyword txl_keyword contained self-path seqp set set-diff
syn keyword txl_keyword contained set-hash-userdata set-indent set-indent-mode set-sig-handler
syn keyword txl_keyword contained setegid setenv seteuid setgid
syn keyword txl_keyword contained setgrent sethash setitimer setlogmask
syn keyword txl_keyword contained setpwent setuid seventh sh
syn keyword txl_keyword contained shift shuffle shut-rd shut-rdwr
syn keyword txl_keyword contained shut-wr sig-abrt sig-alrm sig-bus
syn keyword txl_keyword contained sig-check sig-chld sig-cont sig-fpe
syn keyword txl_keyword contained sig-hup sig-ill sig-int sig-io
syn keyword txl_keyword contained sig-iot sig-kill sig-pipe sig-poll
syn keyword txl_keyword contained sig-prof sig-pwr sig-quit sig-segv
syn keyword txl_keyword contained sig-stkflt sig-stop sig-sys sig-term
syn keyword txl_keyword contained sig-trap sig-tstp sig-ttin sig-ttou
syn keyword txl_keyword contained sig-urg sig-usr1 sig-usr2 sig-vtalrm
syn keyword txl_keyword contained sig-winch sig-xcpu sig-xfsz sign-extend
syn keyword txl_keyword contained sin sixth size-vec slot
syn keyword txl_keyword contained slotp slotset sock-accept sock-bind
syn keyword txl_keyword contained sock-cloexec sock-connect sock-dgram sock-family
syn keyword txl_keyword contained sock-listen sock-nonblock sock-peer sock-recv-timeout
syn keyword txl_keyword contained sock-send-timeout sock-shutdown sock-stream sock-type
syn keyword txl_keyword contained some sort sort-group source-loc
syn keyword txl_keyword contained source-loc-str span-str special-operator-p special-var-p
syn keyword txl_keyword contained splice split split* split-str
syn keyword txl_keyword contained split-str-set sqrt sssucc ssucc
syn keyword txl_keyword contained stat static-slot static-slot-ensure static-slot-p
syn keyword txl_keyword contained static-slot-set stdlib str-in6addr str-in6addr-net
syn keyword txl_keyword contained str-inaddr str-inaddr-net str< str<=
syn keyword txl_keyword contained str= str> str>= stream-get-prop
syn keyword txl_keyword contained stream-set-prop streamp string-extend string-lt
syn keyword txl_keyword contained stringp struct-type struct-type-p structp
syn keyword txl_keyword contained sub sub-list sub-str sub-vec
syn keyword txl_keyword contained subtypep succ super super-method
syn keyword txl_keyword contained suspend swap symacrolet symbol-function
syn keyword txl_keyword contained symbol-macro symbol-name symbol-package symbol-value
syn keyword txl_keyword contained symbolp symlink sys:*lisp1* sys:abscond*
syn keyword txl_keyword contained sys:abscond-from sys:bad-slot-syntax sys:capture-cont sys:cp-origin
syn keyword txl_keyword contained sys:defmeth sys:do-path-test sys:dwim-del sys:dwim-set
syn keyword txl_keyword contained sys:eval-err sys:expand sys:expr sys:fbind
syn keyword txl_keyword contained sys:gc sys:gc-set-delta sys:get-fb sys:get-mb
syn keyword txl_keyword contained sys:get-vb sys:handle-bad-syntax sys:if-to-cond sys:in6addr-condensed-text
syn keyword txl_keyword contained sys:l1-setq sys:l1-val sys:lbind sys:lisp1-setq
syn keyword txl_keyword contained sys:lisp1-value sys:load sys:make-struct-type sys:mark-special
syn keyword txl_keyword contained sys:obtain-impl sys:path-access sys:path-examine sys:path-test
syn keyword txl_keyword contained sys:path-test-mode sys:pl-expand sys:placelet-1 sys:prune-nil-inits
syn keyword txl_keyword contained sys:qquote sys:quasi sys:quasilist sys:reg-expand-nongreedy
syn keyword txl_keyword contained sys:reg-optimize sys:register-simple-accessor sys:rplaca sys:rplacd
syn keyword txl_keyword contained sys:set-macro-ancestor sys:setq sys:setqf sys:splice
syn keyword txl_keyword contained sys:str-inaddr-net-impl sys:struct-lit sys:sym-clobber-expander sys:sym-delete-expander
syn keyword txl_keyword contained sys:sym-update-expander sys:top-fb sys:top-mb sys:top-vb
syn keyword txl_keyword contained sys:unquote sys:var sys:with-saved-vars syslog
syn keyword txl_keyword contained system-package t take take-until
syn keyword txl_keyword contained take-while tan tb tc
syn keyword txl_keyword contained tenth test-set-indent-mode tf third
syn keyword txl_keyword contained throw throwf time time-fields-local
syn keyword txl_keyword contained time-fields-utc time-string-local time-string-utc time-struct-local
syn keyword txl_keyword contained time-struct-utc time-usec to tofloat
syn keyword txl_keyword contained toint tok-str tok-where tostring
syn keyword txl_keyword contained tostringp tprint transpose tree-bind
syn keyword txl_keyword contained tree-case tree-find trie-add trie-compress
syn keyword txl_keyword contained trie-lookup-begin trie-lookup-feed-char trie-value-at trim-str
syn keyword txl_keyword contained true trunc trunc-rem truncate-stream
syn keyword txl_keyword contained tuples txr-case txr-case-impl txr-if
syn keyword txl_keyword contained txr-sym txr-version txr-when typecase
syn keyword txl_keyword contained typeof typep umask umeth
syn keyword txl_keyword contained umethod unget-byte unget-char uniq
syn keyword txl_keyword contained unique unless unquote unsetenv
syn keyword txl_keyword contained until until* unwind-protect upcase-str
syn keyword txl_keyword contained update url-decode url-encode use
syn keyword txl_keyword contained user-package usl usleep uslot
syn keyword txl_keyword contained vec vec-list vec-push vec-set-length
syn keyword txl_keyword contained vecref vector vector-list vectorp
syn keyword txl_keyword contained w-continued w-coredump w-exitstatus w-ifcontinued
syn keyword txl_keyword contained w-ifexited w-ifsignaled w-ifstopped w-nohang
syn keyword txl_keyword contained w-stopsig w-termsig w-untraced wait
syn keyword txl_keyword contained weave when whenlet where
syn keyword txl_keyword contained while while* whilet width
syn keyword txl_keyword contained width-check window-map window-mappend with-clobber-expander
syn keyword txl_keyword contained with-delete-expander with-gensyms with-hash-iter with-in-string-byte-stream
syn keyword txl_keyword contained with-in-string-stream with-objects with-out-string-stream with-out-strlist-stream
syn keyword txl_keyword contained with-resources with-slots with-stream with-update-expander
syn keyword txl_keyword contained wrap wrap* yield yield-from
syn keyword txl_keyword contained zap zerop zip

syn keyword txr_keyword contained accept all and assert
syn keyword txr_keyword contained bind block cases cat
syn keyword txr_keyword contained catch choose chr close
syn keyword txr_keyword contained coll collect data defex
syn keyword txr_keyword contained deffilter define do elif
syn keyword txr_keyword contained else empty end eof
syn keyword txr_keyword contained eol fail filter finally
syn keyword txr_keyword contained first flatten forget freeform
syn keyword txr_keyword contained fuzz gather if include
syn keyword txr_keyword contained last line load local
syn keyword txr_keyword contained maybe merge mod modlast
syn keyword txr_keyword contained name next none or
syn keyword txr_keyword contained output rebind rep repeat
syn keyword txr_keyword contained require set single skip
syn keyword txr_keyword contained some text throw trailer
syn keyword txr_keyword contained try until var
syn match txr_error "\(@[ \t]*\)[*]\?[\t ]*."
syn match txr_atat "\(@[ \t]*\)@"
syn match txr_comment "\(@[ \t]*\)[#;].*"
syn match txr_contin "\(@[ \t]*\)\\$"
syn match txr_char "\(@[ \t]*\)\\."
syn match txr_error "\(@[ \t]*\)\\[xo]"
syn match txr_char "\(@[ \t]*\)\\x[0-9A-Fa-f]\+;\?"
syn match txr_char "\(@[ \t]*\)\\[0-7]\+;\?"
syn match txr_regdir "\(@[ \t]*\)/\(\\/\|[^/]\|\\\n\)*/"
syn match txr_hashbang "^#!.*"
syn match txr_nested_error "[^\t ]\+" contained
syn match txr_variable "\(@[ \t]*\)[*]\?[ \t]*[A-Za-z_][A-Za-z_0-9]*"
syn match txr_splicevar "@[ \t,*@]*[A-Za-z_][A-Za-z_0-9]*"
syn match txr_metanum "@\+[0-9]\+"
syn match txr_badesc "\\." contained
syn match txr_escat "\\@" contained
syn match txr_stresc "\\[abtnvfre\\ \n"`']" contained
syn match txr_numesc "\\x[0-9A-Fa-f]\+;\?" contained
syn match txr_numesc "\\[0-7]\+;\?" contained
syn match txr_regesc "\\[abtnvfre\\ \n/sSdDwW()\|.*?+~&%\[\]\-]" contained

syn match txr_chr "#\\x[0-9A-Fa-f]\+" contained
syn match txr_chr "#\\o[0-7]\+" contained
syn match txr_chr "#\\[^ \t\nA-Za-z_0-9]" contained
syn match txr_chr "#\\[A-Za-z_0-9]\+" contained
syn match txr_ncomment ";.*" contained

syn match txr_dot "\." contained
syn match txr_num "#x[+\-]\?[0-9A-Fa-f]\+" contained
syn match txr_num "#o[+\-]\?[0-7]\+" contained
syn match txr_num "#b[+\-]\?[01]\+" contained
syn match txr_ident "[A-Za-z_0-9!$%&*+\-<=>?\\_~]*[A-Za-z_!$%&*+\-<=>?\\_~^][A-Za-z_0-9!$%&*+\-<=>?\\_~^]*" contained
syn match txl_ident "[:@][A-Za-z_0-9!$%&*+\-<=>?\\_~^/]\+" contained
syn match txr_braced_ident "[:][A-Za-z_0-9!$%&*+\-<=>?\\_~^/]\+" contained
syn match txl_ident "[A-Za-z_0-9!$%&*+\-<=>?\\_~/]*[A-Za-z_!$%&*+\-<=>?\\_~^/#][A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]*" contained
syn match txr_num "[+\-]\?[0-9]\+\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1 contained
syn match txr_badnum "[+\-]\?[0-9]*[.][0-9]\+\([eE][+\-]\?[0-9]\+\)\?[A-Za-z_!$%&*+\-<=>?\\_~^/#]\+" contained
syn match txr_num "[+\-]\?[0-9]*[.][0-9]\+\([eE][+\-]\?[0-9]\+\)\?\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1 contained
syn match txr_num "[+\-]\?[0-9]\+\([eE][+\-]\?[0-9]\+\)\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1 contained
syn match txl_ident ":" contained
syn match txl_splice "[ \t,]\|,[*]" contained

syn match txr_unquote "," contained
syn match txr_splice ",\*" contained
syn match txr_quote "'" contained
syn match txr_quote "\^" contained
syn match txr_dotdot "\.\." contained
syn match txr_metaat "@" contained

syn region txr_bracevar matchgroup=Delimiter start="@[ \t]*[*]\?{" matchgroup=Delimiter end="}" contains=txr_num,txl_ident,txl_splice,txl_metanum,txr_metaat,txr_braced_ident,txr_dot,txr_dotdot,txr_string,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_regex,txr_quasilit,txr_chr,txl_splice,txr_nested_error
syn region txr_directive matchgroup=Delimiter start="@[ \t]*(" matchgroup=Delimiter end=")" contains=txr_keyword,txr_string,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_num,txr_badnum,txl_ident,txl_regex,txr_string,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_list contained matchgroup=Delimiter start="#\?H\?(" matchgroup=Delimiter end=")" contains=txl_keyword,txr_string,txl_regex,txr_num,txr_badnum,txl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_bracket contained matchgroup=Delimiter start="\[" matchgroup=Delimiter end="\]" contains=txl_keyword,txr_string,txl_regex,txr_num,txr_badnum,txl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_mlist contained matchgroup=Delimiter start="@[ \t^',]*(" matchgroup=Delimiter end=")" contains=txl_keyword,txr_string,txl_regex,txr_num,txr_badnum,txl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_mbracket matchgroup=Delimiter start="@[ \t^',]*\[" matchgroup=Delimiter end="\]" contains=txl_keyword,txr_string,txl_regex,txr_num,txr_badnum,txl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_string contained start=+#\?\*\?"+ end=+["\n]+ contains=txr_stresc,txr_numesc,txr_badesc
syn region txr_quasilit contained start=+#\?\*\?`+ end=+[`\n]+ contains=txr_splicevar,txr_metanum,txr_bracevar,txr_mlist,txr_mbracket,txr_escat,txr_stresc,txr_numesc,txr_badesc
syn region txr_regex contained start="/" end="[/\n]" contains=txr_regesc,txr_numesc,txr_badesc
syn region txl_regex contained start="#/" end="[/\n]" contains=txr_regesc,txr_numesc,txr_badesc

hi def link txr_at Special
hi def link txr_atstar Special
hi def link txr_atat Special
hi def link txr_comment Comment
hi def link txr_ncomment Comment
hi def link txr_hashbang Preproc
hi def link txr_contin Preproc
hi def link txr_char String
hi def link txr_keyword Keyword
hi def link txl_keyword Type
hi def link txr_string String
hi def link txr_chr String
hi def link txr_quasilit String
hi def link txr_regex String
hi def link txl_regex String
hi def link txr_regdir String
hi def link txr_variable Identifier
hi def link txr_splicevar Identifier
hi def link txr_metanum Identifier
hi def link txr_escat Special
hi def link txr_stresc Special
hi def link txr_numesc Special
hi def link txr_regesc Special
hi def link txr_badesc Error
hi def link txr_ident Identifier
hi def link txl_ident Identifier
hi def link txr_num Number
hi def link txr_badnum Error
hi def link txr_quote Special
hi def link txr_unquote Special
hi def link txr_splice Special
hi def link txr_dot Special
hi def link txr_dotdot Special
hi def link txr_metaat Special
hi def link txr_munqspl Special
hi def link txl_splice Special
hi def link txr_error Error
hi def link txr_nested_error Error

let b:current_syntax = "lisp"

set lispwords=ado,ap,append-each,append-each*,aret,block,block*,caseq,caseql,casequal,catch,collect-each,collect-each*,cond,conda,condlet,dec,defex,define-accessor,define-modify-macro,define-place-macro,defmacro,defmeth,defparm,defparml,defplace,defstruct,defsymacro,defun,defvar,defvarl,del,delay,do,dohash,dotimes,each,each*,flet,flip,for,for*,fun,gen,gun,handle,handler-bind,ido,if,ifa,iflet,ignerr,ip,labels,lambda,lcons,let,let*,load,mac-param-bind,macro-time,macrolet,mlet,obtain,obtain-block,op,placelet,placelet*,pop,pprof,prof,prog1,progn,push,pushnew,ret,return,return-from,rlet,splice,suspend,symacrolet,sys:abscond-from,sys:expr,sys:fbind,sys:l1-val,sys:lbind,sys:lisp1-value,sys:path-examine,sys:path-test,sys:placelet-1,sys:splice,sys:struct-lit,sys:unquote,sys:var,sys:with-saved-vars,tb,tc,tree-bind,tree-case,txr-case,txr-case-impl,txr-if,txr-when,typecase,unless,unquote,until,until*,unwind-protect,when,whenlet,while,while*,whilet,with-clobber-expander,with-delete-expander,with-gensyms,with-hash-iter,with-in-string-byte-stream,with-in-string-stream,with-objects,with-out-string-stream,with-out-strlist-stream,with-resources,with-slots,with-stream,with-update-expander,yield,yield-from,zap,:method,:function,:init,:postinit,:fini
